#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int main (int argc, char* argv[])
{
  
    int sockfd, send_len;
    struct sockaddr_in multicast_addr;	
    struct in_addr     local_addr;
    char* pMsg;

    // Max Router Num
    char ttl=5;
  
    // multicast addr
    char *multicast_ip = "225.192.0.10";
    int   multicast_port  = 50000;

    // send device ip address [current computer]
    char *local_ip      = "192.168.0.133";

    // sending message
    char *send_message ="Hello multicast";

    pMsg = malloc(sizeof(char) * 20);
    memcpy(pMsg, argv[1], strlen(argv[1]));

    // generatae socket
    sockfd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if (sockfd < 0) 
    {
        printf("Socket open error\n");
        return -1;
    }

    // setting multicast address
    multicast_addr.sin_family      = AF_INET;
    multicast_addr.sin_addr.s_addr = inet_addr(multicast_ip);
    multicast_addr.sin_port        = htons(multicast_port);

    // set the maximum number of routers.
    if(setsockopt(sockfd, IPPROTO_IP, IP_MULTICAST_TTL,(void *)&ttl,sizeof(ttl))<0)
    {
        printf("Socket setsockopt error.[ttl]\n");

        close(sockfd);
        return -1;
    }

    // set the Ip address to be transmitted(local ip)
    local_addr.s_addr = inet_addr(local_ip);    
    if(setsockopt(sockfd, IPPROTO_IP, IP_MULTICAST_IF,(char *)&local_addr, sizeof(local_addr))<0)
    {
        printf("Socket setsockopt error.[Interface]\n");
        close(sockfd);
        return -1;
    }

    // send message
    send_len = sendto(sockfd, pMsg, strlen(pMsg), 0, (struct sockaddr*)&multicast_addr, sizeof(multicast_addr));

    //send_len = sendto(sockfd, send_message, strlen(send_message), 0, (struct sockaddr*)&multicast_addr, sizeof(multicast_addr));
    printf("send len : %d\n",send_len);
    if( send_len < 0 )
    {
        printf("Sending multicast message error");
    }
    else
        printf("Sending multicast message...Success\n");


    free(pMsg);

    close(sockfd);
    return 0;
}
